#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "histogram_internal.h"
#include "svg.h"
#include <curl/curl.h>
#include <string>
#include <sstream>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data(istream& inn, bool promt) {
    Input in;
    if (promt) {
        cerr << "promt: for getting gm in overwatch, u should play supports, cause dps and tanks are 2 hard for noobies \n";
    }
    size_t number_count;
    inn >> number_count;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        inn >> in.numbers[i];
    }
    size_t bin_count;
    inn >> in.bin_count;
    return in;
}

size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

Input
download(const string& address, bool verbose = false) {
    stringstream buffer;
    CURL* curl = curl_easy_init();
    if (curl) {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        if (verbose) {
            curl_easy_setopt(curl, CURLOPT_VERBOSE, "-verbose");
        }
        res = curl_easy_perform(curl);
        curl_easy_cleanup(curl); 
        if (res != CURLE_OK) {
            cout << curl_easy_strerror(res);
            exit(1);
        }
    }
    curl_easy_cleanup(curl);
    return input_data(buffer, false);
}

int main(int argc, char* argv[]) {
    Input input;
    string link;
    bool flag = false;
    if (argc == 2) {
        input = download(argv[1]); 
    }
    else if (argc > 2) {
        for (size_t i = 1; i < argc; i++) {
            string cur = argv[i];
            if (cur.find("://") != string::npos) {
                link = cur;
            }
            else if (cur == "-verbose") {
                flag = true;
            }
            else if (cur.find("-") != string::npos && cur != "-verbose") {
                cout << "Wrong argument, use correct input -verbose or leave input empty" << endl;
                exit(2);
            }
        }
        input = download(link, flag); 
    }
    else {
        input = input_data(cin, true);
    }
    auto bins = make_histogram(input.numbers, input.bin_count);
    show_histogram_svg(bins);
    return 0;
}